"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.runCopy = void 0;
const path = __importStar(require("path"));
const fs_extra_1 = require("fs-extra");
const chalk_1 = __importDefault(require("chalk"));
const copy_1 = require("../service/builder/copy");
const config_1 = require("../config");
function runCopy(appBuildDir, webRuntimeAppData, options) {
    return __awaiter(this, void 0, void 0, function* () {
        const timeTag = '-------------------- runCopy ';
        console.time(timeTag);
        const srcFiles = [
            'src/index.less',
            'src/handlers',
            'src/utils',
            'html',
            'webpack',
            'src/libraries',
        ];
        console.log(chalk_1.default.blue.bold('Copying files:'));
        for (const entry of srcFiles) {
            const dstFile = path.join(appBuildDir, entry);
            console.log(dstFile);
            yield fs_extra_1.copy(path.join(config_1.appTemplateDir, entry), dstFile);
        }
        yield copy_1.copyEntryFile(appBuildDir, webRuntimeAppData, options.adminPortalKey);
        console.timeEnd(timeTag);
    });
}
exports.runCopy = runCopy;
