"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.runHandleKbonePlugin = exports.runHandleMpPlugin = void 0;
const plugin_1 = require("../service/builder/plugin");
function runHandleMpPlugin(appBuildDir, plugins) {
    return __awaiter(this, void 0, void 0, function* () {
        console.time('runHandleMpPlugin');
        yield plugin_1.installMpPlugin(appBuildDir, plugins);
        console.timeEnd('runHandleMpPlugin');
    });
}
exports.runHandleMpPlugin = runHandleMpPlugin;
function runHandleKbonePlugin(appBuildDir, plugins, mpConfig) {
    return __awaiter(this, void 0, void 0, function* () {
        console.time('runHandleKbonePlugin');
        yield plugin_1.installKbonePlugin(appBuildDir, plugins);
        yield plugin_1.mergeKbonePluginConfig(appBuildDir, plugins, mpConfig);
        console.timeEnd('runHandleKbonePlugin');
    });
}
exports.runHandleKbonePlugin = runHandleKbonePlugin;
