"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.getCodeModuleFilePath = exports.isStyleFile = void 0;
function isStyleFile(mod) {
    return mod.type === 'style' || mod.type === 'theme';
}
exports.isStyleFile = isStyleFile;
function getCodeModuleFilePath(pageId, mod, exts = {}) {
    var _a, _b, _c, _d, _e;
    let file = ``;
    if ((_a = mod === null || mod === void 0 ? void 0 : mod.path) === null || _a === void 0 ? void 0 : _a.startsWith('comp-')) {
        file = `/${mod.path.replace(/comp-\w+/, '')}`;
    }
    else if ((_b = mod === null || mod === void 0 ? void 0 : mod.path) === null || _b === void 0 ? void 0 : _b.startsWith('$comp/')) {
        file = `/${mod.path.replace(/^\$comp\//, '/')}`;
    }
    else if ((_c = mod === null || mod === void 0 ? void 0 : mod.path) === null || _c === void 0 ? void 0 : _c.startsWith('$comp')) {
        file = `/${mod.path.replace(/\$comp_\d+/, '')}`;
    }
    else if (pageId === 'global') {
        file = `/${(_d = mod === null || mod === void 0 ? void 0 : mod.path) === null || _d === void 0 ? void 0 : _d.replace(/^global/, '')}`;
    }
    else {
        file = `/${(_e = mod === null || mod === void 0 ? void 0 : mod.path) === null || _e === void 0 ? void 0 : _e.replace(/.*?\//, `${pageId}/`)}`;
    }
    return file + (isStyleFile(mod) ? exts.style || '.less' : '.js');
}
exports.getCodeModuleFilePath = getCodeModuleFilePath;
